clc
echo on


%%%%
%%% ESERCIZIO 1
%%%

%Definizione della f.d.t. d'anello
L=tf(100,conv([1 2 1],[0.01 1]))
pause

%Calcolo del margine di fase e della pulsazione critica
margin(L),grid
pause

%Approssimazione con un sistema del 2 ordine a poli complessi coniugati
[mum,fim,wp,wc] = margin(L)
csi=sin((fim/2)*(pi/180))
mu=dcgain(L)/(1+dcgain(L));
Fapp=tf(mu*wc^2,[1 2*csi*wc wc^2])
pause

%Confronto tra risposta sistema reale ed approssimato
F=feedback(L,1)
step(F,Fapp),grid
pause


%%%%
%%% ESERCIZIO 2
%%%

%Definizione della f.d.t. d'anello con R1
G=10*tf([-2 1],[10 1]);
R1=0.02*tf([10 1],[0.2 1 0]);
L1=R1*G
pause

%Verifica della risposta allo scalino
F1=feedback(L1,1);
step(F1),grid
pause

%Definizione della f.d.t. d'anello con R2
R2=0.036*tf([10 1],[0.1 1 0]);
L2=R2*G
margin(L2),grid
pause

%Confronto dei diagrammi di Nyquist di L1 e L2
nyquist(L1,L2)
pause

%Verifica a fronte di un errore di guadagno di G
Gp=1.35*G;
L1=R1*Gp; L2=R2*Gp;
nyquist(L1,L2),axis equal
pause


%%%%
%%% ESERCIZIO 3
%%%

%Definizione delle f.d.t. d'anello
G=tf(10,[10 1 0]);
R1=0.03*tf([10 1],[1/3 1]);
R2=0.03*tf([10 1],[0.1 1]);
R3=0.03*tf([10 1],[1   1]);
L1=R1*G
L2=R2*G
L3=R3*G
pause

%Confronto le tre funzioni di trasferimento d'anello
bode(L1,L2,L3),grid
pause
margin(L1),grid
pause
margin(L2),grid
pause
margin(L3),grid
pause

%Definizione delle funzioni di sensitivit del controllo
Q1=R1/(1+R1*G)
Q2=R2/(1+R2*G)
Q3=R3/(1+R3*G)
pause

%Confronto le tre funzioni di sensitivit del controllo
bode(Q1,Q2,Q3),grid
pause

%Confronto l'andamento della variabile controllata/di controllo con i tre regolatori
F1=feedback(L1,1);
F2=feedback(L2,1);
F3=feedback(L3,1);
t  = 0:0.001:70;
yo = 5*sin(0.1*t)+sin(3*t);
y1 = lsim(F1,yo,t);
y2 = lsim(F2,yo,t);
y3 = lsim(F3,yo,t);
u1 = lsim(Q1,yo,t);
u2 = lsim(Q2,yo,t);
u3 = lsim(Q3,yo,t);
subplot(2,1,1),plot(t,y1,t,y2,t,y3),grid,xlabel('Tempo [s]'),ylabel('y')
subplot(2,1,2),plot(t,u1,t,u2,t,u3),grid,xlabel('Tempo [s]'),ylabel('u')
